
extras = {}

extras.state = "main"

extras.totalt = 0

extras.arty = {
	love.graphics.newImage("images/1.jpeg"),
	love.graphics.newImage("images/2.jpeg"),
	love.graphics.newImage("images/3.jpeg"),
	love.graphics.newImage("images/Pacman 1.png"),
	love.graphics.newImage("images/Pacman 2.png"),
	love.graphics.newImage("images/Spoke 3.png"),
	zoom = 0,
	zooom = 1,
	x = 0,
	y = 0,
	x1 = 0,
	y1 = 0,
}

extras["art"] = {}

extras["art"].buttons = {
	{
		x = 10,
		y = 490,
		width = 200,
		height = 100,
		text = {
			held = "BACK!",
			--selected = "",
			left = "Back?",
		},
		held = false,
		func = function(x,y)
			if extras.arty.zoom == 0 then
				extras.state = "main"
			else
				extras.arty.zoom = 0
			end
		end,
	},
}

extras["viewer"] = {}

extras["viewer"].buttons = {
	{
		x = 10,
		y = 490,
		width = 200,
		height = 100,
		text = {
			held = "BACK!",
			--selected = "",
			left = "Back?",
		},
		held = false,
		func = function(x,y)
			extras.state = "main"
		end,
	},
}

extras["viewer"].walk = 0
extras["viewer"].afraid = false

extras["main"] = {}

extras["main"].buttons = {
	{
		x = 195,
		y = 90,
		width = 200,
		height = 100,
		text = {
			held = "ORIGINAL ARTWORK!",
			--selected = "",
			left = "Original Artwork?",
		},
		held = false,
		func = function(x,y)
			extras.state = "art"
		end,
	},
	{
		x = 405,
		y = 90,
		width = 200,
		height = 100,
		text = {
			held = "VIEWER!",
			--selected = "",
			left = "Viewer?",
		},
		held = false,
		func = function(x,y)
			extras.state = "viewer"
		end,
	},
	{
		x = 10,
		y = 490,
		width = 200,
		height = 100,
		text = {
			held = "BACK!",
			--selected = "",
			left = "Back?",
		},
		held = false,
		func = function(x,y)
			gamemode = "menu"
		end,
	},
}

extras.mousepressed = function(x,y,button)
	if button == "l" then
		for b = 1, table.getn(extras[extras.state].buttons) do
			if x > extras[extras.state].buttons[b].x and y > extras[extras.state].buttons[b].y and x < extras[extras.state].buttons[b].x + extras[extras.state].buttons[b].width and y < extras[extras.state].buttons[b].y + extras[extras.state].buttons[b].height then
				extras[extras.state].buttons[b].func()
				break
			end
		end
		if extras.state == "art" then
			local cnt = -1
			local yy = 20
			local offset = 0
			for i = 1,table.getn(extras.arty) do
				cnt = cnt + 1
				if cnt == 2 then
					cnt = 0
					yy = yy + 400 / 1.5 + 10
					if i == table.getn(extras.arty) then
						if even(i) == false then
							offset = 100
						end
					end
				end
				if x > extras.arty.x1 + math.mod(i - 1,2) * 210 + 190 + offset and x < extras.arty.x1 + math.mod(i - 1,2) * 210 + 190 + offset + 200 and y > extras.arty.y1 + yy and y < extras.arty.y1 + yy + 400 / 1.5 then
					extras.arty.zoom = i
				end
			end
		end
	elseif button == "wu" then
		extras.arty.zooom = extras.arty.zooom * (4/3)
	elseif button == "wd" then
		extras.arty.zooom = extras.arty.zooom * (3/4)
	end
end

extras.update = function(dt)
	if love.keyboard.isDown("left") then
		extras["viewer"].walk = 1
	elseif love.keyboard.isDown("up") then
		extras["viewer"].walk = 2
	elseif love.keyboard.isDown("right") then
		extras["viewer"].walk = 3
	elseif love.keyboard.isDown("down") then
		extras["viewer"].walk = 4
	end
	if love.keyboard.isDown(" ") then
		extras["viewer"].afraid = true
	else
		extras["viewer"].afraid = false
	end
	extras.totalt = extras.totalt + dt
	for b = 1, table.getn(extras[extras.state].buttons) do
		if mouse_x > extras[extras.state].buttons[b].x and mouse_y > extras[extras.state].buttons[b].y and mouse_x < extras[extras.state].buttons[b].x + extras[extras.state].buttons[b].width and mouse_y < extras[extras.state].buttons[b].y + extras[extras.state].buttons[b].height then
			extras[extras.state].buttons[b].held = true
		else
			extras[extras.state].buttons[b].held = false
		end
	end
	nx = mouse_x
	ny = mouse_y
	if love.mouse.isDown("m") then
		if extras.arty.zoom > 0 then
			extras.arty.x = extras.arty.x + nx - px
			extras.arty.y = extras.arty.y + ny - py
		else
			extras.arty.x1 = extras.arty.x1 + nx - px
			extras.arty.y1 = extras.arty.y1 + ny - py
		end
	end
	px = mouse_x
	py = mouse_y
end

extras.draw = function()
	love.graphics.setLineWidth(1)
	for b = 1, table.getn(extras[extras.state].buttons) do
		love.graphics.setColor(255,255,255,255)
		if extras[extras.state].buttons[b].held == true then
			love.graphics.rectangle("fill",extras[extras.state].buttons[b].x,extras[extras.state].buttons[b].y,extras[extras.state].buttons[b].width,extras[extras.state].buttons[b].height)
			love.graphics.setColor(0,0,0,255)
			love.graphics.print(extras[extras.state].buttons[b].text.held,extras[extras.state].buttons[b].x + extras[extras.state].buttons[b].width / 2 - love.graphics.getFont():getWidth(extras[extras.state].buttons[b].text.held) / 2,extras[extras.state].buttons[b].y + extras[extras.state].buttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
		else
			love.graphics.rectangle("line",extras[extras.state].buttons[b].x,extras[extras.state].buttons[b].y,extras[extras.state].buttons[b].width,extras[extras.state].buttons[b].height)
			love.graphics.print(extras[extras.state].buttons[b].text.left,extras[extras.state].buttons[b].x + extras[extras.state].buttons[b].width / 2 - love.graphics.getFont():getWidth(extras[extras.state].buttons[b].text.left) / 2,extras[extras.state].buttons[b].y + extras[extras.state].buttons[b].height / 2 - love.graphics.getFont():getHeight() / 2)
		end
	end
	if extras.state == "viewer" then
		love.graphics.setColor(255,255,255,255)
		love.graphics.rectangle("fill",10,10,780,470)
		amnag.pathman.animate(200,300,{anim_state = math.mod(extras.totalt,1),walk = extras["viewer"].walk,afraid = extras["viewer"].afraid},150)
		ghost.animate(600,300,{anim_state = math.mod(extras.totalt,1),walk = extras["viewer"].walk,afraid = extras["viewer"].afraid},150)
	elseif extras.state == "art" then
		love.graphics.setColor(255,255,255,255)
		if extras.arty.zoom > 0 then
			love.graphics.draw(extras.arty[extras.arty.zoom], extras.arty.x - 200 * extras.arty.zooom + 400, extras.arty.y - ((400 / 0.75) / 2) * extras.arty.zooom + 300,0,300 / extras.arty[extras.arty.zoom]:getWidth() / 0.75 * extras.arty.zooom,400 / extras.arty[extras.arty.zoom]:getHeight() / 0.75 * extras.arty.zooom)
		else
			local cnt = -1
			local yy = 20
			local offset = 0
			for i = 1,table.getn(extras.arty) do
				cnt = cnt + 1
				if cnt == 2 then
					cnt = 0
					yy = yy + 400 / 1.5 + 10
					if i == table.getn(extras.arty) then
						if even(i) == false then
							offset = 100
						end
					end
				end
				love.graphics.draw(extras.arty[i],extras.arty.x1 + math.mod(i - 1,2) * 210 + 290 + offset, extras.arty.y1 + yy,0,300 / extras.arty[i]:getWidth() / 1.5,400 / extras.arty[i]:getHeight() / 1.5)
			end
		end
	end
end
